/* 
 *
 * Copyright (c) 2003 Phil Ringnalda
 *
 * Based on original code Copyright (c) 2001-2002  Ted Mielczarek
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


var bloggertoolMenuItems = new Array("bloggertool-sep", "bloggertool-bloggertool");

var BloggerTool = {
  init: function() {
    var menu = document.getElementById("contentAreaContextMenu");
    menu.addEventListener("popupshowing",BloggerTool.showHide,false);
  },

  showHide: function() {
/*    var isTextSelection = false;

    if(gContextMenu)
      isTextSelection = gContextMenu.isTextSelected;
*/
    for(var i=0; i<bloggertoolMenuItems.length; i++) {
      var menuitem = document.getElementById(bloggertoolMenuItems[i]);
      if(menuitem) {
//        menuitem.hidden = !isTextSelection;
        menuitem.hidden = false;
      }
    }
  },

  quote: function(e) {
	var target = window.content.document;
	this.quoteWithBloggerTool(gContextMenu.searchSelected(), target.location.href, target.title);
  },

  quoteWithBloggerTool: function(selected_text, target_url, site_title, cgi_url) 
  {
	var browser = getBrowser();
	
	// get the user prefs 
	var preferences       = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	var user_blog_cgi     = get_option_value_by_name(preferences, "bloggertool.userblog.cgi");
	var user_blog_title   = get_option_value_by_name(preferences, "bloggertool.userblog.titlevar");
	var user_blog_content = get_option_value_by_name(preferences, "bloggertool.userblog.contentvar");
	var user_blog_custom  = get_option_value_by_name(preferences, "bloggertool.userblog.customvars");
	var quotation_prefix  = get_option_value_by_name(preferences, "bloggertool.quotation.prefix");

	if (! user_blog_custom) {
		user_blog_custom = "";
	}

	if (! quotation_prefix) {
		quotation_prefix = "Quoting ";
	}

	if (! (user_blog_cgi && user_blog_title && user_blog_content)) {
		alert("Unable to get the full website settings ! You have to configure bloggertool.");
		bloggertool_options();
		return false;
	}
	
	// build the blog entry
        var body = "<p>" + quotation_prefix + " <a href=\""+target_url+"\">" + site_title + "</a></p>";
	    body += "<blockquote cite=\""+target_url+"\">" + selected_text + "</blockquote>";
	var user_input = prompt("Enter the title", quotation_prefix + " " + site_title);

	// build the blog url to post content
	var bloggerURL = user_blog_cgi     + "?";
	bloggerURL    += user_blog_title   + "=" + user_input + "&";
	bloggerURL    += user_blog_content + "=" + escape(body) + "&";
	bloggerURL    += user_blog_custom;

	// open the window for posting
	window.open(bloggerURL, "_blank", "");
  },
}

// do the init on load
window.addEventListener("load",BloggerTool.init, false); 

